/*------------------------------------------------------------------------------*/
/* TFC UNIVERSIDAD OBERTA DE CATALUNYA                                          */
/*      I.T. Telecomunicaciones - Telemtica                                    */
/*           Visor de senderismo para mviles con OpenLayers                    */
/*                                                                              */
/*                                                                              */
/* Alumno/a: Francisco Jess Villaseor Garca                                  */
/* Dirigido por: Victor Velarde Gutierrez                                       */
/* CURSO 2011-12 Febrero                                                        */
/*                                                                              */
/* Fichero de constantes del proyecto                                           */
/*------------------------------------------------------------------------------*/

/* Datos del proyecto. */
var PROYECTO = 'tfc-sig-uoc-fvillasenor';
var NAMESPACE_PROYECTO = 'http://www.uoc.es/tfc/sig/2011-12/fvillasenor';
var SRID_GOOGLE="EPSG:900913";
var DIR_IMAGENES = "tfc-sig-uoc-fvillasenor-imagenes";

/* Datos de conectividad. */
var URL_GEOSERVER = 'http://localhost:8080/geoserver/'+PROYECTO;
var WFS = 'wfs';
var WMS = 'wms';
var URL_GEOSERVER_WFS = URL_GEOSERVER+'/'+WFS;
var URL_GEOSERVER_WMS = URL_GEOSERVER+'/'+WMS;

var FORMATO_IMAGEN='image/png';
var FORMATO_TEXTO='text/plain';
var FORMATO_GML2='GML2';

/* Capa de rutas. */
var RUTA = 'vruta';
var PROPIEDAD_RUTA_CODIGO = 'codigo';
var PROPIEDAD_RUTA_NOMBRE = 'nombre';
var PROPIEDAD_RUTA_DESCRIPCION = 'descripcion';
var PROPIEDAD_RUTA_DIFICULTAD = 'dificultad';
var PROPIEDAD_RUTA_DESCRIPCION = 'descripcion';
var PROPIEDAD_RUTA_LONGITUD = 'longitud';
var PROPIEDAD_RUTA_DESNIVEL = 'desnivel';
var PROPIEDAD_RUTA_CAMINO = 'camino';
var PROPIEDAD_RUTA_DESC_DIFICULTAD = 'grado_dificultad';
var LAYER_RUTA = PROYECTO+':'+RUTA;

/* Capa de puntos de interes. */
var PINTERES = 'vpunto_interes';
var PROPIEDAD_PINTERES_NOMBRE = 'nombre';
var PROPIEDAD_PINTERES_DESCRIPCION = 'descripcion';
var PROPIEDAD_PINTERES_TIPO = 'tipo';
var PROPIEDAD_PINTERES_UBICACION = 'ubicacion';
var PROPIEDAD_PINTERES_DESC_TIPO = 'tipo_pi';
var LAYER_PINTERES = PROYECTO+':'+PINTERES;

/* Propiedades comunes. */
var PROPIEDAD_WFS_FID = 'fid';

/* Lista de propiedades a recuperar en el buscador inicial. */
var PROPIEDADES_CONSULTA_RUTAS_BUSCADOR=PROPIEDAD_RUTA_CODIGO+','+PROPIEDAD_RUTA_NOMBRE+','+PROPIEDAD_RUTA_DIFICULTAD+','+PROPIEDAD_RUTA_CAMINO;

/* Lista de propiedades a recuperar en el detalle de la rura. */
var PROPIEDADES_CONSULTA_RUTA_DETALLE=PROPIEDAD_RUTA_NOMBRE+','+PROPIEDAD_RUTA_DESCRIPCION+','+PROPIEDAD_RUTA_DESC_DIFICULTAD+','+PROPIEDAD_RUTA_LONGITUD+','+PROPIEDAD_RUTA_DESNIVEL;

/* Parametros basicos de la invocacion en una peticion WMS GetFeature. */
var PARAMETERS_WFS_GET_FEATURE = { REQUEST: "GetFeature", SERVICE: "WFS", VERSION: "1.1.0", outputFormat: FORMATO_GML2};

/* Parametros basicos de la invocacion en una peticion WMS GetFeature. */
var PARAMETERS_WMS_GET_FEATURE_INFO = { REQUEST: "GetFeatureInfo", SERVICE: "WMS", VERSION: "1.1.1", format: FORMATO_IMAGEN, info_format: FORMATO_TEXTO};

/* ETIQUETAS DE LAS PAGINAS */
var CABECERA_RESULTADOS = "<h2>Rutas localizadas</h2>";
var SIN_RESULTADOS ="No se han encontrado datos para la busqueda";
var ERROR ="ERROR AL CARGAR LOS DATOS";

/* IMAGENES */
var ICONO_FACIL = DIR_IMAGENES+"/facil.png";
var ICONO_MEDIO = DIR_IMAGENES+"/medio.png";
var ICONO_DIFICIL = DIR_IMAGENES+"/dificil.png";
var ICONO_INICIORUTA = DIR_IMAGENES+"/inicioruta.png";
var ICONO_FINRUTA = DIR_IMAGENES+"/finruta.png";
var ICONO_USUARIO = DIR_IMAGENES+"/usuario.png";
var LOGO_PANORAMIO = DIR_IMAGENES+"/logo-small.gif";
var LOGO_FLICKR = DIR_IMAGENES+"/flickr-yahoo-logo.png";
var ICONO_PANORAMIO= DIR_IMAGENES+"/panoramio-marker.png";
var ICONO_FLICKR= DIR_IMAGENES+"/dot1_p.png";

/* URLS externas. */
var URL_PANORAMIO = 'www.paronamio.com';
var URL_SERV_PANORAMIO = 'http://www.panoramio.com/map/get_panoramas.php';
var URL_FLICKR = 'www.flickr.com';
var URL_SERV_FLICKR = 'http://api.flickr.com/services/rest/';


/* Parametros de panoramio. */
/* set public (popular photos)  full (all photos) user ID number. */
/* size original medium (default value) small thumbnail square mini_square. */
/*  mapfilter parameter is set to true, photos are filtered such that they look better when they are placed on a map */
var PARAMETERS_URL_SERV_PANORAMIO = {set:'public', from:0, to:25, size:'thumbnail', mapfilter: true};
var PANORAMIO_NOMBRE_CAPA = "Panoramio";

/* Parametros de Flickr. */
/* Los datos del api de busqueda estan en http://www.flickr.com/services/api/flickr.photos.search.html */
var PARAMETERS_URL_SERV_FLICKR = {api_key:'afe543860cf655a59c9e300207cf1ba1', privacy_filter:1, per_page:25, content_type:1, format:'json', method:'flickr.photos.search', tags :'Cuenca'};
var PARAMETERS_URL_SERV_FLICKR_INFO = {api_key:'afe543860cf655a59c9e300207cf1ba1', format:'json', method:'flickr.photos.getInfo'};
var FLICKR_NOMBRE_CAPA = "Flickr";
