/*------------------------------------------------------------------------------*/
/* TFC UNIVERSIDAD OBERTA DE CATALUNYA                                          */
/*      I.T. Telecomunicaciones - Telemtica                                    */
/*           Visor de senderismo para mviles con OpenLayers                    */
/*                                                                              */
/*                                                                              */
/* Alumno/a: Francisco Jess Villaseor Garca                                  */
/* Dirigido por: Victor Velarde Gutierrez                                       */
/* CURSO 2011-12 Febrero                                                        */
/*                                                                              */
/* Fichero de funciones de utilidad general                                     */
/*------------------------------------------------------------------------------*/

/**
 * Funcion que recupera un valor en un conjunto de lineas tipo nombre=valor.
 */
function encontrar(lineas,nombre) {
	var encontrado=false;
	var resultado = '';
	for (var iCnt=0; iCnt<lineas.length && !encontrado ; iCnt++) {
		var valor = lineas[iCnt].split("=");
		if (valor[0].toLowerCase().indexOf(nombre)>=0) {
			encontrado = true;
			resultado = valor[1];
		}
	}
	return resultado;
}


/**
 * Funcion que hace un trim de una cadena por ambos lados.
 */
function trim(valor) {
	var resultado = valor;
	var iCnt=0;
	var jCnt=0;
	for ( iCnt=0; iCnt<valor.length; iCnt++) { if (valor[iCnt]!=' ') break; }
	for ( jCnt=valor.length-1; jCnt>=0; jCnt--) { if (valor[jCnt]!=' ') break; }
	resultado = valor.substr(iCnt,valor.length-jCnt);
	return resultado;
}

/**
 * Funcion que redondea un numero a la centena inferior.
 */
function redondeaCentenaMenor(valor) {
	return parseInt(valor/100)*100
}

/**
 * Funcion que redondea un numero a la centena superior.
 */
function redondeaCentenaMayor(valor) {
	return (parseInt(valor/100)*100)+100;
}

/**
 * Funcion que normaliza un numero flotante poniento P en lugar de punto.
 */
function normaliza(valor) {
	var resultado=''+valor;
	resultado = resultado.replace('.','P');
	return resultado;
}

/**
 * Funcion que desnormaliza una  cadena con P en lugar de punto a numero flotante.
 */
function desnormaliza(valor) {
	var aux = valor.replace('P','.');
	return parseFloat(aux);
}

/**
 * Funcion que formatea un numero y lo deja con 2 decimales.
 */
function formatea(num) {
	return parseInt(num * 100.0) / 100.0; 	
}

/**
 * Funcion que comprueba si la peticion ha finalizado correctamente.
 */
function peticionOk(response) {
	return response && response.status=="200" && response.responseText.indexOf("ServiceException")<0;
}

/**
 * Cierra todos los popups de un mapa.
 */
function cerrarTodosPopups(map) {
	if (map.popups && map.popups.length) {
		for (var iCnt=0; iCnt<map.popups.length; iCnt++)
			map.removePopup(map.popups[iCnt]);
	}
}

/**
 * Ajusta el mapa para su correcta visualizacion
 * Esta funcion se usa por efectos observados en la carga de mapas tras pulsar el boton volver
 *	y volver a cargar el mapa que hacia que no se visualizase correctamente las capas tipo overlay
 */
function ajustaMapa(map){
	map.pan(0,1);
	map.pan(0,-1);
	map.layers[0].redraw();
}

/**
 * Trata de obtener un zoom aproximado para google en funcion de los pixesl y del tamano
 * en grados del mapa, porque zoomToExtent() no parece ajustar bien
 * Copiada de http://dfowler.geeksbox.co.uk/files/mapstraction
 */
function getGoogleZoom(pixels, grados) {
  return Math.round((Math.log((360 * pixels) / grados) / Math.log(2)) - 8);
}
