/*------------------------------------------------------------------------------*/
/* TFC UNIVERSIDAD OBERTA DE CATALUNYA                                          */
/*      I.T. Telecomunicaciones - Telemtica                                    */
/*           Visor de senderismo para mviles con OpenLayers                    */
/*                                                                              */
/*                                                                              */
/* Alumno/a: Francisco Jess Villaseor Garca                                  */
/* Dirigido por: Victor Velarde Gutierrez                                       */
/* CURSO 2011-12 Febrero                                                        */
/*                                                                              */
/* Fichero de funciones del proyecto                                            */
/*                                                                              */
/*                                                                              */
/* Depende de la libreria OpenLayers.js -- OpenLayers Map Viewer Library        */
/* Copyright 2005-2011 OpenLayers Contributors, released under the FreeBSD      */
/* license. Please see http://svn.openlayers.org/trunk/openlayers/license.txt   */
/* for the full text of the license.                                            */
/*                                                                              */
/* Depende de la libreria jQuery Mobile -- jQuery Mobile Framework 1.0          */
/* http://jquerymobile.com                                                      */
/* Copyright 2011 (c) jQuery Project                                            */
/* Dual licensed under the MIT or GPL Version 2 licenses.                       */
/* http://jquery.org/license                                                    */
/*                                                                              */
/* Depende de la libreria jQuery --jQuery JavaScript Library v1.6.4             */
/* http://jquery.com/                                                           */
/* Copyright 2011, John Resig                                                   */
/* Dual licensed under the MIT or GPL Version 2 licenses.                       */
/* http://jquery.org/license                                                    */
/*                                                                              */
/*------------------------------------------------------------------------------*/

/* VARIABLES GLOBALES */
/** Operacion sobre el mapa: true alturas e info de los puntos de interes. False: perfil topografico. */
var __OPERACION__=true;
/** Contenido del popup sobre el mapa. */
var __HTML_POPUP__=''; 
/** Layer para pintar los puntos seleccionados por el usuario para generar el perfil topografico. */
var __LAYER_PERFIL__ = new OpenLayers.Layer.Vector("Topografa",{displayInLayerSwitcher:false});
/** Elementos asignados al LAYER_PERFIL. */
var __ELEMENTOS_LAYER_PERFIL__ = new Array();
/** Auxiliar para almacenar las longitudes/latitudes de ELEMENTOS_LAYER_PERFIL para invocar a google. */
var __ELEMENTOS_LAYER_PERFIL_LONLAT__ = new Array();
/** Panel de control de opciones propias dentro del mapa de OpenLayer. */
var __CONTROL_PANEL__ ;

/**
 * Funcion de inicilizacion de los eventos jQuery Mobile
 */
function init() {
	// Inicizalizacin de eventos de la pagina: buscador
	$( '#buscador' ).live( 'pageinit',function(event){

		// Evento de buscar
		$("#buscador_buscar").click( function(event){
			var texto_libre = document.getElementById('buscador_texto').value;
			var select_nivel_dificultad = document.getElementById('buscador_nivel_dificultad');
			var nivel_dificultad = select_nivel_dificultad.options[select_nivel_dificultad.selectedIndex].value;
			if (nivel_dificultad==' ') nivel_dificultad='';		

			buscar(texto_libre,nivel_dificultad,event);
		});
	});

	// Control de acceso a la pantalla del mapa

	$(document).bind( "pagebeforechange", function( event, data ){

		if (typeof data.toPage =='string' && data.toPage.indexOf('#mapa')>=0) {

			var parametros = data.toPage.substring(data.toPage.indexOf('?')+1,data.toPage.length);
			var parametro = parametros.split('&');
			var fid = parametro[0].split('=')[1];		
			var minX = desnormaliza(parametro[1].split('=')[1]);
			var minY = desnormaliza(parametro[2].split('=')[1]);
			var maxX = desnormaliza(parametro[3].split('=')[1]);
			var maxY = desnormaliza(parametro[4].split('=')[1]);
				
			ver_mapa(fid,event,minX,minY,maxX,maxY);
		}
	});
	
	// Inicizalizacin de eventos de la pagina: buscador
	$( '#informacion_detallada' ).live( 'pageinit',function(event){

		// Evento de buscar
		$("#operacion_altura").click( function(event){
			__OPERACION__ = true;
			cambiaBotonAlturas();
			// Redirecciona por cdigo
			$.mobile.changePage($('#mapa'));
		});
		
		$("#operacion_perfil").click( function(event){
			__OPERACION__ = false;
			cambiaBotonAlturas();
			// Redirecciona por cdigo
			$.mobile.changePage($('#mapa'));
		});
	});

}

/**
 * Funcion que implementa el buscador de la pantalla inicial.
 * texto_libre - valor del campo de busqueda de texto libre
 * nivel_dificultad - nivel_dificultad valor del campo de busqueda nivel de dificultad
 * e - evento del usuario
 */
function buscar(texto_libre,nivel_dificultad,e) {
	var _cql_filter;
	var and = false;
	
	// Recupera la busqueda por texto
	if (texto_libre) {
		_cql_filter = "("+PROPIEDAD_RUTA_NOMBRE+" LIKE '%"+texto_libre+"%' OR "+PROPIEDAD_RUTA_DESCRIPCION+" LIKE '%"+texto_libre+"%')";
		and = true;
	}

	// Recupera la busqueda por nivel de dificultas
	var _dificultad = nivel_dificultad;
	if (nivel_dificultad) {
		if (and) _cql_filter+=" AND "; else _cql_filter="";
		_cql_filter += "("+PROPIEDAD_RUTA_DIFICULTAD+"='"+nivel_dificultad+"')";
		and = true;
	}
	
	// Rellena los parametros
	var params = PARAMETERS_WFS_GET_FEATURE;
	params.propertyName=PROPIEDADES_CONSULTA_RUTAS_BUSCADOR;
	params.typeName=LAYER_RUTA;
	params.cql_filter=_cql_filter;
	
	// Ejecuta la peticion
	OpenLayers.loadURL(URL_GEOSERVER_WFS, params, this, pintaResultadoBuscar, pintaResultadoBuscar);
	OpenLayers.Event.stop(e);
}

/**
 * Funcion Handler que se invoca tras la llamada a la peticion de buscar.
 * Se carga en la pagina de resultados, que despues se refresca.
 * Se apoya en el parseador GML de OpenLayers
 * response - respuesta a la peticion
 */
function pintaResultadoBuscar(response) {
	var xml = response.responseText;
	var html = CABECERA_RESULTADOS;
	var ok = peticionOk(response);
	var sinDatos = false;
	if (!ok)
	{
		html += ERROR;
	}else {
		var format = new OpenLayers.Format.GML();
		var datos = format.read(xml);
	
		if (datos.length==0) {
			html += SIN_RESULTADOS;
			sinDatos = true;
		}
		else {
			html += '<div id="resultados_busqueda">&nbsp;</div>';
			html += '<ul data-role="listview" data-filter="true">';
			for (var iCnt in datos) {
				var codigo = eval('datos[iCnt].attributes.'+PROPIEDAD_RUTA_CODIGO);
			
				// Calculamos los limites de la geometria recuperada
				datos[iCnt].geometry.calculateBounds();
			
				// Seleccionamos el icono
				var dificultad = eval('datos[iCnt].attributes.'+PROPIEDAD_RUTA_DIFICULTAD);
				var srcimg = ICONO_FACIL;
				if (dificultad=='M') srcimg = ICONO_MEDIO;
				else if (dificultad=='D') srcimg = ICONO_DIFICIL;
			
				// Pintamos los resultados
				html += '<li><a href="#mapa?id='+codigo;
				html += '&minX='+normaliza(datos[iCnt].geometry.bounds.bottom);
				html += '&minY='+normaliza(datos[iCnt].geometry.bounds.left);
				html += '&maxX='+normaliza(datos[iCnt].geometry.bounds.top);
				html += '&maxY='+normaliza(datos[iCnt].geometry.bounds.right);
				html += '">';
				html += '<img src="'+srcimg+'" alt="Dificultad" class="ui-li-icon">'
				html += eval('datos[iCnt].attributes.'+PROPIEDAD_RUTA_NOMBRE)+'</a></li>';
			}
			html += '</ul>';
		}
	}

	// Carga los datos
	var $page = $('#resultados')
	$content = $page.children( ":jqmData(role=content)" )
	$content.html( html );
			
	// Refresca la pagina	
	$page.page();
	if (ok && !sinDatos)
		$content.find( ":jqmData(role=listview)" ).listview();
	
	// Redirecciona por cdigo
	$.mobile.changePage($('#resultados'));
}

/**
 * Funcion invocada para visualizar el mapa.
 * Se carga en el div "visualizar_mapa" del html.
 * idruta - ruta a mostrar
 * e - evento de pulsar el formulario
 * minX,minY,maxX,maxY - limites de la ruta recuperada
 */
function ver_mapa(idruta,e,minX,minY,maxX,maxY) {
	// Inicializacion de los datos
	document.getElementById("visualizacion_mapa").innerHTML = "";
	__OPERACION__=true;
	__LAYER_PERFIL__.removeAllFeatures();
	__ELEMENTOS_LAYER_PERFIL__.length=0;
	
	// left, bottom, right, top es las coordenadas originales
	var ruta_seleccionada = idruta;
	var limites_mapa = new OpenLayers.Bounds(minX,minY,maxX,maxY);
	
	// Coordenadas del mapa para google
	var sph_mercator1 = OpenLayers.Layer.SphericalMercator.forwardMercator(limites_mapa.left,limites_mapa.bottom);
	var sph_mercator2 = OpenLayers.Layer.SphericalMercator.forwardMercator(limites_mapa.right,limites_mapa.top);
	var limites_mapa_google = new OpenLayers.Bounds(sph_mercator1.lon,sph_mercator1.lat,sph_mercator2.lon,sph_mercator2.lat);
	// Calcula el centro del mapa para Google
	var sph_mercator = OpenLayers.Layer.SphericalMercator.forwardMercator(limites_mapa.getCenterLonLat().lon,limites_mapa.getCenterLonLat().lat);

	// Opciones del mapa
	// Se selecciona la proyeccion que utiliza Google (Mercator Esferica) y los limites del mapa en estas coordenadas
  var opciones_mapa = {
		projection: new OpenLayers.Projection(SRID_GOOGLE),
		maxExtent: limites_mapa_google
	};

	// Crea el mapa
	var map = new OpenLayers.Map("visualizacion_mapa", opciones_mapa);
	map.addControl(new OpenLayers.Control.LayerSwitcher());
	
	// Crear control para posicionamiento del usuario
	// enableHighAccuracy: indica si se quiere la mayor precision (implica mas tiempo o mas consumo)
	// timeout: tiempo maximo desde que se solicita una posicion hasta que se obtiene (en ms, maximo Infinity)
	// maximumAge: tiempo maximo de la cache de posiciones (ms, 0 indica que se quiere la posicion actual)
	var control_posicion_usuario = new OpenLayers.Control.Geolocate({
        id: 'control_posicion_usuario',
        geolocationOptions: { enableHighAccuracy: true,  maximumAge: 0, timeout: 5000 }});
	
	var capa_posicion_usuario = new OpenLayers.Layer.Vector("Posicion Usuario",{displayInLayerSwitcher:false});
	
	// Evento que se lanza cuando se actualiza la posicion
	control_posicion_usuario.events.register("locationupdated", this, function(e) {
		capa_posicion_usuario.removeAllFeatures();
		var posicion = OpenLayers.Layer.SphericalMercator.forwardMercator(e.point.x,e.point.y);
    capa_posicion_usuario.addFeatures([
    	new OpenLayers.Feature.Vector(
				new OpenLayers.Geometry.Point(posicion.lon,posicion.lat), null,
					{externalGraphic: ICONO_USUARIO, graphicHeight: 18, graphicWidth: 18})
			]);
	});
	
	map.addControl(control_posicion_usuario);
	
	// Control dentro de OpenLayers que realiza la misma funcion que el boton de la ventana de popUp
	var control_button = new OpenLayers.Control.Button({
    displayClass: "olControlBoton", 
    trigger: function() { 
    	__OPERACION__ = !__OPERACION__;
    	cambiaBotonAlturas();
    }
	});
	__CONTROL_PANEL__ = new OpenLayers.Control.Panel({type: OpenLayers.Control.TYPE_BUTTON, 
		title:'Permite cambiar entre alturas y perfil topogrfico al igual que la ventana de informacin', 
		displayClass: 'olControlPanel'});
	__CONTROL_PANEL__.addControls([control_button]);
	map.addControl(__CONTROL_PANEL__);

	// Capas de Google
	var capa_google_maps = new OpenLayers.Layer.Google(
		  "Google Maps",
		  {numZoomLevels: 22});
	var capa_google_terreno = new OpenLayers.Layer.Google(
		  "Google Terreno",
		  {type: google.maps.MapTypeId.TERRAIN, numZoomLevels: 22});
	var capa_google_hibrida = new OpenLayers.Layer.Google(
		  "Google Hibrida",
		  {type: google.maps.MapTypeId.HYBRID, numZoomLevels: 22});	
	var capa_google_satelite = new OpenLayers.Layer.Google(
	    "Google Satelite",
	    {type: google.maps.MapTypeId.SATELLITE, numZoomLevels: 22});
	
	// Capa de Open Street Maps    
	var capa_osm = new OpenLayers.Layer.OSM(
			"OpenStreetMap", null, 
			{numZoomLevels: 22});

	// Capa de la ruta seleccionada
	var capa_rutas = new OpenLayers.Layer.WMS(
		    "Rutas", URL_GEOSERVER_WMS,
		    {
		        layers: LAYER_RUTA,
		        STYLES: '',
		        cql_filter: '('+PROPIEDAD_RUTA_CODIGO+'='+ruta_seleccionada+')',
		        transparent: "true",
		        format: FORMATO_IMAGEN
		    },
        {isBaseLayer: false,displayInLayerSwitcher: false}
		);

	// Capa de los puntos de interes
	var capa_puntos_interes = new OpenLayers.Layer.WMS(
		    "Puntos de Inters", URL_GEOSERVER_WMS,
		    {
		        layers: LAYER_PINTERES,
		        STYLES: '',
		        transparent: "true",
		        format: FORMATO_IMAGEN
		    },
        {isBaseLayer: false,displayInLayerSwitcher: false}
		);

	// Anyade las capas al mapa
	map.addLayers([capa_google_maps,capa_google_terreno,capa_google_hibrida,capa_google_satelite,capa_osm,capa_rutas,capa_puntos_interes,capa_posicion_usuario]);
	
	// Pinta el mapa
	var zoomInicial = map.getZoomForExtent(limites_mapa_google);
	map.setCenter(new OpenLayers.LonLat(sph_mercator.lon, sph_mercator.lat),zoomInicial,false,true);
	  // getGoogleZoom (400,limites_mapa.right-limites_mapa.left));

	// Pinta la informacin completa de la ruta
	// Rellena los parametros
	var params = PARAMETERS_WFS_GET_FEATURE;
	params.propertyName=PROPIEDADES_CONSULTA_RUTA_DETALLE;
	params.typeName=LAYER_RUTA;
	params.cql_filter='('+PROPIEDAD_RUTA_CODIGO+'='+ruta_seleccionada+')';
	
	// Ejecuta la peticion
	OpenLayers.loadURL(URL_GEOSERVER_WFS, params, this, pintaInfoRuta, pintaInfoRuta);
	
	// Registramos el evento de hacer click en el mapa
	// Lo incluimos como una funcion sin declarar fuera porque necesitamos los datos del mapa
	map.events.register('click', map, 
		function (e) {
			logicaPulsacionUsuario(e,map);
			OpenLayers.Event.stop(e);
		}
	);

	// Posicionamos al usuario
	if (control_posicion_usuario.active) {
  	control_posicion_usuario.getCurrentLocation();
  } else {
		control_posicion_usuario.activate();
	}
	//posicionarUsuario(map)
	
	cargarPanoramio(map,limites_mapa);
	cargarFlickr(map,limites_mapa);
	
	ajustaMapa(map);
}

/**
 * Funcion que trata de pintar la posicion del usuario si tiene GPS.
 *	Ahora no se utiliza, se usa el control proporcionado por OpenLayers
 */
function posicionarUsuario(map) {
	//Comprue si hay geolocalizacion en el navegador
	if( navigator.geolocation ) {
			// Prepara la capa para pintar la posicion del usuario
			var capa_posicion_usuario = new OpenLayers.Layer.Vector("Posicion Usuario");
			
			// Funcion que intercepta la localizacion del usuario
			function pintaPosicionUsuario(pos){
				var sph_mercator;
				if( pos.coords ){ 
						sph_mercator = OpenLayers.Layer.SphericalMercator.forwardMercator(pos.coords.longitude,pos.coords.latitude);
				}
				else{
						sph_mercator = OpenLayers.Layer.SphericalMercator.forwardMercator(pos.longitude,pos.latitude);
				}
				
				var posicionUsuario = new OpenLayers.Feature.Vector(
					new OpenLayers.Geometry.Point(sph_mercator.lon,sph_mercator.lat), null,
								{externalGraphic: ICONO_USUARIO, graphicHeight: 18, graphicWidth: 18});
				
				capa_posicion_usuario.addFeatures(posicionUsuario);
				map.addLayer(capa_posicion_usuario);
			}	
		
			// Localiza la posicion
			navigator.geolocation.getCurrentPosition(pintaPosicionUsuario, null, {enableHighAccuracy:true, maximumAge: 300000});
	}
}

/**
 * Funcion Handler que se invoca tras la llamada a la peticion de buscar en el punto de buscar informacion de la ruta.
 * Se carga en el div "informacion_detallada_ruta" del html.
 * Se apoya en el parseador GML de OpenLayers
 */
function pintaInfoRuta(response) {
	var html = '';
	var ok = peticionOk(response);
	if (!ok) {
		html=ERROR;
	}else {
		var xml = response.responseText;
		var format = new OpenLayers.Format.GML();
		var datos = format.read(xml);
		
		for (var iCnt in datos) {
			html= '<p><strong>Nombre:</strong>'+eval('datos[iCnt].attributes.'+PROPIEDAD_RUTA_NOMBRE)+'<br/>';
			html+= '<strong>Descripcion:</strong>'+eval('datos[iCnt].attributes.'+PROPIEDAD_RUTA_DESCRIPCION)+'<br/>';
			html+= '<strong>Dificultad:</strong>'+eval('datos[iCnt].attributes.'+PROPIEDAD_RUTA_DESC_DIFICULTAD)+'<br/>';
			html+= '<strong>Longitud:</strong>'+formatea(eval('datos[iCnt].attributes.'+PROPIEDAD_RUTA_LONGITUD))+' Km.<br/>';
			html+= '<strong>Max. desnivel:</strong>'+eval('datos[iCnt].attributes.'+PROPIEDAD_RUTA_DESNIVEL)+'%</p>';
		}
	}
	document.getElementById("informacion_detallada_ruta").innerHTML = html;
}

/**
 * Identifica la logica a realizar ante un ebento del usuario sobre el mapa.
 */
function logicaPulsacionUsuario(e,map) {
	if (__OPERACION__) { // Alturas e informacion de los puntos de interes
		altutaInfoPuntoInteres(e,map);
	}else { // Perfiles topogrficos
		perfilTopografico(e,map);
	}
}

/**
 * Operativa normal sobre el mapa: altura e informacion de los puntos de inters
 */
function altutaInfoPuntoInteres(e,map) {
	__HTML_POPUP__ = '';
	cerrarTodosPopups(map);
	
	if ( map.getLayersByName(__LAYER_PERFIL__.name).length>0) {
		map.removeLayer(__LAYER_PERFIL__);
		__LAYER_PERFIL__.removeAllFeatures();
		__ELEMENTOS_LAYER_PERFIL__.length=0;
	}

	// Obtiene la informacion del punto de interes
	var params = PARAMETERS_WMS_GET_FEATURE_INFO;
	params.X=e.xy.x;
	params.Y=e.xy.y;
	params.QUERY_LAYERS=LAYER_PINTERES;
	params.LAYERS=LAYER_PINTERES;
	params.BBOX=map.getExtent().toBBOX();
	params.WIDTH=map.size.w;
	params.HEIGHT=map.size.h;
	params.SRS=map.layers[0].projection;

	OpenLayers.loadURL(URL_GEOSERVER_WMS, params, this, pintaPuntoInteres, pintaPuntoInteres);
	OpenLayers.Event.stop(e);

	// Obtiene la informacion de la altura del punto seleccionado
	var google_elevation = new google.maps.ElevationService();
	var localizacion = [];
	var coordenadasDelEvento = map.layers[0].getMapObjectLonLatFromMapObjectPixel(e.xy);

  // Generamos el objeto LatLong de google API
  localizacion.push(coordenadasDelEvento);

  // Creamos la peticion a Google Elevation
  var peticion = {'locations': localizacion}

  // Realizamos la peticion
  if (google_elevation) {
	 	google_elevation.getElevationForLocations(peticion,	function(resultado, status) {
			if (status == google.maps.ElevationStatus.OK) {
				__HTML_POPUP__+= '<strong>Altura:</strong> '+formatea(resultado[0].elevation)+' m.';
			}
			
			//Calculamos donde pintar el popup en el mapa
			var sph_mercator = OpenLayers.Layer.SphericalMercator.forwardMercator(coordenadasDelEvento.Oa,coordenadasDelEvento.Na);
	
			// Pintamos el resultado en un pop-up de openlayers
			map.addPopup(new OpenLayers.Popup(null,
		     sph_mercator, //,
		     new OpenLayers.Size(200,__HTML_POPUP__.indexOf("Nombre:")>=0 ? 100 : 25),
		     __HTML_POPUP__,
		     true
		  ));
		});
	}
}

/**
 * Funcion Handler que se invoca tras el click en un punto del mapa que tenga asociado un punto de interes.
 * El texto se recibe en formato de texto plano
 */
function pintaPuntoInteres(response) {
	var ok = peticionOk(response);
	if (ok) {
		var texto = response.responseText;
		var lineas = response.responseText.split('\n');
		if (lineas.length>2) {
			__HTML_POPUP__ = '<strong>Nombre:</strong>'+encontrar(lineas,PROPIEDAD_PINTERES_NOMBRE)+'<br/>';
			__HTML_POPUP__+= '<strong>Descripcion:</strong>'+encontrar(lineas,PROPIEDAD_PINTERES_DESCRIPCION)+'<br/>';
			__HTML_POPUP__+= '<strong>Tipo:</strong>'+encontrar(lineas,PROPIEDAD_PINTERES_DESC_TIPO)+'<br/>';
		}
	}
}

/**
 * Operativa del mapa para obtener el perfil topogrfico.
 */
function perfilTopografico(e,map) {
	__HTML_POPUP__ = '';
	cerrarTodosPopups(map);
	
	//Si se pulsa de nuevo y es para obtener un nuevo perfil se elimina la seleccion anterior 
	if (map.getLayersByName(__LAYER_PERFIL__.name).length>0 && __ELEMENTOS_LAYER_PERFIL__.length==3) {
		map.removeLayer(__LAYER_PERFIL__);
		__LAYER_PERFIL__.removeAllFeatures();
	}
		
	// Obtenemos la latitud/longitud del pixel asociado a la pulsacion
	var coordenadasDelEvento = map.layers[0].getMapObjectLonLatFromMapObjectPixel(e.xy);
	
	//Calculamos donde pintar el popup en el mapa
	var sph_mercator = OpenLayers.Layer.SphericalMercator.forwardMercator(coordenadasDelEvento.Oa,coordenadasDelEvento.Na);
		
	// Primera seleccion sobre el mapa
	if (__ELEMENTOS_LAYER_PERFIL__.length==0 || __ELEMENTOS_LAYER_PERFIL__.length==3) {
		// Definimos el punto a pintar						
		__ELEMENTOS_LAYER_PERFIL__[0] = new OpenLayers.Feature.Vector(
			new OpenLayers.Geometry.Point(sph_mercator.lon,sph_mercator.lat),	null,
						{externalGraphic: ICONO_INICIORUTA, graphicHeight: 18, graphicWidth: 18});
		
		// Conservamos la latitud/longitud para Google
		__ELEMENTOS_LAYER_PERFIL_LONLAT__[0] = coordenadasDelEvento;
		__ELEMENTOS_LAYER_PERFIL__.length=1;
	}
	// Siguiente seleccion
	else {
		// Definimos el punto a pintar	
		__ELEMENTOS_LAYER_PERFIL__[1] = new OpenLayers.Feature.Vector(
			new OpenLayers.Geometry.Point(sph_mercator.lon,sph_mercator.lat),	null,
						{externalGraphic: ICONO_FINRUTA, graphicHeight: 18, graphicWidth: 18});
		
		// Conservamos la latitud/longitud para Google
		__ELEMENTOS_LAYER_PERFIL_LONLAT__[1] = coordenadasDelEvento;
		
		// Definimos la linea entre los puntos
		__ELEMENTOS_LAYER_PERFIL__[2] = new OpenLayers.Feature.Vector(
			new OpenLayers.Geometry.LineString([__ELEMENTOS_LAYER_PERFIL__[0].geometry, __ELEMENTOS_LAYER_PERFIL__[1].geometry]), null,
						{'strokeWidth': 3, 'strokeColor': 'blue'});
	}

	// Pintamos el layer de la seleccion del usuario en el mapa
	for (var iCnt=0; iCnt<__ELEMENTOS_LAYER_PERFIL__.length; iCnt++)
		__LAYER_PERFIL__.addFeatures(__ELEMENTOS_LAYER_PERFIL__[iCnt]);
	if (map.getLayersByName(__LAYER_PERFIL__.name).length==0) {
		map.addLayer(__LAYER_PERFIL__);
	}
	
	// Si se completa la seleccion obtenemos el perfil topografico
	if (__ELEMENTOS_LAYER_PERFIL__.length==3) {
		var google_elevation = new google.maps.ElevationService();
		var ruta = [__ELEMENTOS_LAYER_PERFIL_LONLAT__[0], __ELEMENTOS_LAYER_PERFIL_LONLAT__[1]];
		
		// Creamos la peticion a Google Elevation
		var peticion = { 'path': ruta, 'samples': 100 };
			  
		if (google_elevation) {
			google_elevation.getElevationAlongPath(peticion, function(resultado, status) {
				
				if (status == google.maps.ElevationStatus.OK) {
					var maxelevacion = -20000;
		      var minelevacion = 20000;
		      var img_srccoordenadas='';
		      
		      // Construimos las alturas para Google Chart y calculamos la elevacion mxima / mnimo
		      for (var i = 0; i < resultado.length; i++) {
						if (i>0) img_srccoordenadas+=',';
						img_srccoordenadas+=resultado[i].elevation;
						if (resultado[i].elevation>maxelevacion) maxelevacion=resultado[i].elevation;
						if (resultado[i].elevation<minelevacion) minelevacion=resultado[i].elevation;
					}
					
					// Redonde las elevaciones
					minelevacion=redondeaCentenaMenor(minelevacion);
					maxelevacion=redondeaCentenaMayor(maxelevacion);
					
					// Construimos la peticion para Google Chart
					var img_src = 'http://chart.apis.google.com/chart?cht=lc&chxt=x,y&chds='+minelevacion+','+maxelevacion+'&chl=Elevacion+en+Metros&chco=orange&chs=500x160&chxr=1,'+minelevacion+','+maxelevacion+'&chd=t:'
		      img_src+=img_srccoordenadas;
					
					// Preparamos el html del popup 
					__HTML_POPUP__='<img src="'+img_src+'" />';
					
					// Pintamos el resultado en un pop-up de openlayers
					map.addPopup(new OpenLayers.Popup(null,
				     sph_mercator, //,
				     new OpenLayers.Size(520,180),
				     __HTML_POPUP__,
				     true
				  ));
				}
			});
		}
	}
}

/**
 * Cambia el boton entre ayuda y perfil topografico
 */
function cambiaBotonAlturas() {
	document.getElementById(__CONTROL_PANEL__.id).getElementsByTagName("div")[0].className='olControlBoton'+(__OPERACION__ ?'ItemInactive':'ItemActive');
}

/**
 * Carga las imagenes de panoramio en una capa inicialmente invisible
 */
function cargarPanoramio(map,limites_mapa) {
	var request_panoramio = PARAMETERS_URL_SERV_PANORAMIO;
	request_panoramio.minx=limites_mapa.left;
	request_panoramio.miny=limites_mapa.bottom;
	request_panoramio.maxx=limites_mapa.right;
	request_panoramio.maxy=limites_mapa.top;
	
	// Funcion que atiende la peticion
	// Se pone aqui para poder pasarle el mapa		
	function __pintarImagenesPanoramio(response) {
		pintarImagenesPanoramio(map,response);
	}
			
	OpenLayers.loadURL(URL_SERV_PANORAMIO, request_panoramio, this, __pintarImagenesPanoramio, __pintarImagenesPanoramio);
}

/**
 * Pinta la capa de imagenes de panoramio.
 * Los datos devueltos por panoramio y los requerimientos para mostrarlos estan en http://www.panoramio.com/api/data/api.html
 */
function pintarImagenesPanoramio(map,response) {
	var ok = peticionOk(response);
	if (ok) {
		var json = response.responseText;
		var format = new OpenLayers.Format.JSON();
		var datos = format.read(json);
			
		if ( map.getLayersByName(PANORAMIO_NOMBRE_CAPA).length>0) {
			map.removeLayer(map.getLayersByName(PANORAMIO_NOMBRE_CAPA)[0]);
		}
		
		if (datos.photos.length > 0) {

			var iCnt=0;
			var fotos = new Array();
			for (iCnt=0; iCnt<datos.photos.length; iCnt++) {
				var sph_mercator = OpenLayers.Layer.SphericalMercator.forwardMercator(datos.photos[iCnt].longitude,datos.photos[iCnt].latitude);
				var foto_loc = new OpenLayers.Geometry.Point(sph_mercator.lon,sph_mercator.lat);
				fotos[iCnt] = new OpenLayers.Feature.Vector(foto_loc,	datos.photos[iCnt], 
					{externalGraphic: ICONO_PANORAMIO, graphicHeight: 18, graphicWidth: 18});
			}
			
			// Capa de fotos de panoramio
			var fotos_panoramio = new OpenLayers.Layer.Vector(PANORAMIO_NOMBRE_CAPA,{visibility:false});
			for (iCnt=0; iCnt<fotos.length; iCnt++)
				fotos_panoramio.addFeatures(fotos[iCnt]);
			map.addLayer(fotos_panoramio);
			
			// Funcion que atiende la pulsacion del usuario sobre la foto
			// Se pone aqui para poder pasarle el mapa		
			function __seleccionarFotoPanoramio(foto) {
				seleccionarFotoPanoramio(map,foto);
			}
			
			// Control para interceptar la pulsacion del usuario sobre la foto
			var panoramio_control = new OpenLayers.Control.SelectFeature(fotos_panoramio, {onSelect: __seleccionarFotoPanoramio});
			map.addControl(panoramio_control);
			panoramio_control.activate();
		}
	}
}

/**
 * Responde al evento de pulsar sobre una imagen de panoramio.
 */
function seleccionarFotoPanoramio(map,foto) {
	cerrarTodosPopups(map);
	
	var html = "<a href='"+URL_PANORAMIO+"' target='_blank'><img src='"+LOGO_PANORAMIO+"'/></a><br>";
	html +="<strong>"+ foto.attributes.photo_title + "</strong><br>";
  html +="<a href='"+ foto.attributes.photo_url+"' target='_blank'><img src='"+foto.attributes.photo_file_url+"' border='0'></a><br>";
	html +="<i>Autor</i>:<a href='"+ foto.attributes.owner_url+"' target='_blank'>"+foto.attributes.owner_name +"</a>";
	html +="<div style='font-size: 9px;'>Las fotos provistas por Panoramio se hallan bajo el copyright de sus propietarios</div>";
          
	//Calculamos donde pintar el popup en el mapa
	var sph_mercator = OpenLayers.Layer.SphericalMercator.forwardMercator(foto.attributes.longitude,foto.attributes.latitude);
	
	// Pintamos el resultado en un pop-up de openlayers
	map.addPopup(new OpenLayers.Popup(null,
		sph_mercator, //,
		new OpenLayers.Size(250,200),
		html,
		true
	));
}

/**
 * Carga las imagenes de Flickr en una capa inicialmente invisible
 */
function cargarFlickr(map,limites_mapa) {
	var request_flickr = PARAMETERS_URL_SERV_FLICKR;
	request_flickr.bbox=limites_mapa.left+','+limites_mapa.bottom+','+limites_mapa.right+','+limites_mapa.top;
			
	// Funcion que atiende la peticion
	// Se pone aqui para poder pasarle el mapa
	function __pintarImagenesFlickr(response) {
		pintarImagenesFlickr(map,response);
	}
			
	OpenLayers.loadURL(URL_SERV_FLICKR, request_flickr, this, __pintarImagenesFlickr, __pintarImagenesFlickr);
}
		
/**
 * Pinta la capa de imagenes de panoramio.
 */
function pintarImagenesFlickr(map,response) {
	var ok = peticionOk(response);
	if (ok) {
		var json = response.responseText;
		var format = new OpenLayers.Format.JSON();
		json = json.substring("jsonFlickrApi(".length,json.length-1);
		var datos = format.read(json);
				
		if ( map.getLayersByName(FLICKR_NOMBRE_CAPA).length>0) {
			map.removeLayer(map.getLayersByName(FLICKR_NOMBRE_CAPA)[0]);
		}
		
		// Control de erroes propio de Flickr		
		if (datos.stat=='ok' && datos.photos.photo.length>0 ) {
				
			var iCnt=0;
			var flickr = new OpenLayers.Layer.Vector(FLICKR_NOMBRE_CAPA,{visibility:false});
					
			for (iCnt=0; iCnt<datos.photos.photo.length; iCnt++) {
				var request_flickr = PARAMETERS_URL_SERV_FLICKR_INFO;
				request_flickr.photo_id=datos.photos.photo[iCnt].id

				// Funcion que pinta la imagen de flickr
				// Se hace asi porque es necesario previamente obtener la informacion de la imagen
				// en un segundo servicio
				function __ponerImagenFlickr(response) {
					var ok = peticionOk(response);
					if (ok) {
						var jsonInfo = response.responseText;
						var formatInfo = new OpenLayers.Format.JSON();
						jsonInfo = jsonInfo.substring("jsonFlickrApi(".length,jsonInfo.length-1);
						var datosInfo = format.read(jsonInfo);
						
						if (datosInfo.stat=='ok') {
							var sph_mercator = OpenLayers.Layer.SphericalMercator.forwardMercator(datosInfo.photo.location.longitude,datosInfo.photo.location.latitude);
							var foto_loc = new OpenLayers.Geometry.Point(sph_mercator.lon,sph_mercator.lat);
							flickr.addFeatures(new OpenLayers.Feature.Vector(foto_loc,	datosInfo.photo, 
								{externalGraphic: ICONO_FLICKR, graphicHeight: 18, graphicWidth: 18}));
						}
					}
				}
						
				OpenLayers.loadURL(URL_SERV_FLICKR, request_flickr, this, __ponerImagenFlickr, __ponerImagenFlickr);
			}
						
			map.addLayer(flickr);
						
			function __seleccionarFotoFlickr(foto) {
				seleccionarFotoFlickr(map,foto);
			}
						
			var flickr_control = new OpenLayers.Control.SelectFeature(flickr, {onSelect: __seleccionarFotoFlickr});
			map.addControl(flickr_control);
			flickr_control.activate();
		}
	}
}

/**
 * Responde al evento de pulsar sobre una imagen de panoramio.
 * Como formar las URLS se indica en http://www.flickr.com/services/api/misc.urls.html
 */
function seleccionarFotoFlickr(map,foto) {
	cerrarTodosPopups(map);
	
	var photopage = '#';
	for (var iCnt=0; iCnt<foto.attributes.urls.url.length; iCnt++) {
		if (foto.attributes.urls.url[iCnt].type=='photopage')
			photopage = foto.attributes.urls.url[iCnt]._content;
	}
			
	var html = "<a href='"+URL_FLICKR+"' target='_blank'><img src='"+LOGO_FLICKR+"'/></a><br>";
  html+="<strong>"+ foto.attributes.title._content + "</strong><br>";
  html+="<a href='"+ photopage+"' target='_blank'/><img src='http://farm"+foto.attributes.farm+".staticflickr.com/"+foto.attributes.server+"/"+foto.attributes.id+"_"+foto.attributes.secret+"_t.jpg' border='0'></a><br>";
	html+="<i>Autor</i>:<a href='http://www.flickr.com/photos/"+ foto.attributes.owner.nsid+" target='_blank'/'>"+foto.attributes.owner.username +"</a>";
          
	//Calculamos donde pintar el popup en el mapa
	var sph_mercator = OpenLayers.Layer.SphericalMercator.forwardMercator(foto.attributes.location.longitude,foto.attributes.location.latitude);
	
	// Pintamos el resultado en un pop-up de openlayers
	map.addPopup(new OpenLayers.Popup(null,
		sph_mercator, //,
		new OpenLayers.Size(250,175),
		html,
		true
	));
}
