CREATE TABLE TGRADO_DIFICULTAD (codigo CHAR(1) PRIMARY KEY, nombre VARCHAR(50) NOT NULL);

CREATE TABLE TTIPO (codigo CHAR(2) PRIMARY KEY, nombre VARCHAR(50) NOT NULL);

CREATE TABLE TRUTA (codigo SERIAL PRIMARY KEY, 
nombre VARCHAR(100) NOT NULL,
descripcion TEXT,
desnivel SMALLINT,
dificultad CHAR(1) REFERENCES TGRADO_DIFICULTAD(codigo));

SELECT AddGeometryColumn( 'truta', 'camino', 4326, 'LINESTRING', 2);

CREATE TABLE TPUNTO_INTERES (codigo SERIAL PRIMARY KEY, 
nombre VARCHAR(100) NOT NULL,
descripcion TEXT,
tipo CHAR(2) REFERENCES TTIPO(codigo));

SELECT AddGeometryColumn( 'tpunto_interes', 'ubicacion', 4326, 'POINT', 2);

CREATE VIEW VRUTA AS
SELECT 
R.codigo, R.nombre, R.descripcion, ST_Length(ST_Transform(R.camino,23030))/1000 as longitud, R.desnivel, 
R.dificultad, R.camino, G.nombre as grado_dificultad
FROM
TRUTA R, TGRADO_DIFICULTAD G
WHERE 
R.dificultad=G.codigo and ST_IsValid(R.camino);

INSERT INTO geometry_columns VALUES ('','public','vruta','camino', 2, 4326, 'LINESTRING' );

CREATE VIEW VPUNTO_INTERES AS
SELECT 
P.codigo, P.nombre, P.descripcion, P.tipo, P.ubicacion, T.nombre as tipo_pi
FROM
TTIPO T, TPUNTO_INTERES P
WHERE 
P.tipo=T.codigo and ST_IsValid(P.ubicacion);

INSERT INTO geometry_columns VALUES ('','public','vpunto_interes','ubicacion', 2, 4326, 'POINT' );
